package com.galaxis.manatee.task;

import com.galaxis.manatee.dao.ChuanyunDayWorkAbcDao;
import com.galaxis.manatee.entity.chuanyun.data.object.ChuanyunDayWorkAbcDO;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.time.Instant;
import java.util.List;
import java.util.Map;
import java.util.UUID;

/**
 * @author zcj
 * @version 0.1
 * @date 2020/8/9 11:01 下午
 */
@Service
@Slf4j
public class WorkHourAnalysis {

    private final ChuanyunDayWorkAbcDao chuanyunDayWorkAbcDao;

    public WorkHourAnalysis(ChuanyunDayWorkAbcDao chuanyunDayWorkAbcDao) {
        this.chuanyunDayWorkAbcDao = chuanyunDayWorkAbcDao;
    }

    //    @Scheduled(fixedDelay = 3600000L)
    private void standardDayWorkAbcHour() {
        standardDayAbcHour();
    }

    /**
     * 员工工时abc分析
     */
    private void standardDayAbcHour() {
        log.info("开始更新工时abc分析数据");
        long startTime= Instant.now().getEpochSecond();
        List<Map> dayWorkAbcList = chuanyunDayWorkAbcDao.queryDayWorkAbc();
        dayWorkAbcList.forEach(dayWork -> {
            try {
                String projectId = (String)dayWork.get("project_id");
                String projecrtName = (String)dayWork.get("project_name");
                String projectCode = (String)dayWork.get("project_code");
                BigDecimal totalTime = (BigDecimal)dayWork.get("total_time");
                ChuanyunDayWorkAbcDO dayWorkAbcDO = new ChuanyunDayWorkAbcDO();
                ChuanyunDayWorkAbcDO planDayWorkAbc = chuanyunDayWorkAbcDao.queryDayWorkAbcTotalTime(projectId, 0);
                if(planDayWorkAbc != null) {
                    dayWorkAbcDO.setPlanTime(planDayWorkAbc.getTotalTime());
                }
                ChuanyunDayWorkAbcDO sellDayWorkAbc = chuanyunDayWorkAbcDao.queryDayWorkAbcTotalTime(projectId, 1);
                if(sellDayWorkAbc != null) {
                    dayWorkAbcDO.setSellTime(sellDayWorkAbc.getTotalTime());
                }
                ChuanyunDayWorkAbcDO otherWorkAbc = chuanyunDayWorkAbcDao.queryDayWorkAbcTotalTime(projectId, 2);
                if(otherWorkAbc != null) {
                    dayWorkAbcDO.setOtherTime(otherWorkAbc.getTotalTime());
                }
                ChuanyunDayWorkAbcDO chuanyunDayWorkAbcDO = chuanyunDayWorkAbcDao.findByProjectId(projectId);
                if (chuanyunDayWorkAbcDO != null) {
                    chuanyunDayWorkAbcDao.delete(chuanyunDayWorkAbcDO);
                }
                dayWorkAbcDO.setObjectId(UUID.randomUUID().toString());
                dayWorkAbcDO.setProjectId(projectId);
                dayWorkAbcDO.setProjectCode(projectCode);
                dayWorkAbcDO.setProjectName(projecrtName);
                dayWorkAbcDO.setTotalTime(totalTime);
                chuanyunDayWorkAbcDao.save(dayWorkAbcDO);
            }catch(Exception e) {
                log.error(e.getMessage());
                e.printStackTrace();
            }
        });

        log.info("周工时abc分析耗时"+(Instant.now().getEpochSecond()-startTime)+"秒");
    }
}
